unit iMisc;

interface

uses
    Windows, SysUtils, Forms, ShellAPi, ShlObj, ActiveX, ComObj;

procedure SimpleMessage(const s: string);
function GetStartUpFolderPath(): string;
procedure CreateStartup();
procedure SimpleExecute(const Path: string);
function SimpleOkCancel(const s: string): Boolean;
    
implementation

//  ---------------------------------------------------------------------------
//  bZ[W
procedure SimpleMessage(const s: string);
var
    Flag: integer;
begin
    Flag := MB_ICONINFORMATION + MB_OK;
    Application.MessageBox(PChar(s), PChar(Application.Title), Flag);
end;

//  ---------------------------------------------------------------------------
//  bZ[W
function SimpleOkCancel(const s: string): Boolean;
var
    Flag: integer;
begin
    Flag := MB_ICONQUESTION + MB_OKCANCEL;
    Result := Application.MessageBox(PChar(s), PChar(Application.Title), Flag) = IDOK;
end;

//  ---------------------------------------------------------------------------
//  ShellExecute
procedure SimpleExecute(const Path: string);
begin
    ShellExecute(Application.Handle, nil, PChar(Path), nil, nil, SW_SHOW);
end;

//  ---------------------------------------------------------------------------
//  X^[gAbvtH_
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink

function GetStartUpFolderPath(): string;
var
    pidlPath: PItemIDList;
    StartupPath: array[0..MAX_PATH] of Char;
begin
    SHGetSpecialFolderLocation(Application.Handle, CSIDL_STARTUP, pidlPath);
    SHGetPathFromIDList(pidlPath, StartupPath);
    Result := StartupPath;
end;

//  ---------------------------------------------------------------------------
//  X^[gAbvɓo^
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink

procedure CreateStartup();
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
    StartupPath: string;
begin
    //  V[gJbg̐ݒ
    FileName := ParamStr(0);
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile:= ShellLink as IPersistFile;
    //  t@ČɎw肷p[^
    ShellLink.SetArguments('/starup');
    //  st@C̃tpX
    ShellLink.SetPath(PChar(FileName));
    //  ƃtH_
    ShellLink.SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    //  X^[gAbvpX̎擾
    StartupPath := GetStartUpFolderPath();
    //  V[gJbgt@C̍쐬
    LinkFileName := ChangeFileExt(ExtractFileName(FileName),'.lnk'); 
    LinkFileName := Format('%s\%s',[StartupPath, LinkFileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));
end;

//  ---------------------------------------------------------------------------
//  http://homepage1.nifty.com/MADIA/delphi/delphi_bbs/200308_03080004.html

initialization
    CoInitialize(nil);
finalization
    CoUninitialize();
end.

