unit iReminder;

interface

uses
    Windows, SysUtils, Classes, Contnrs, DateUtils, IniFiles, iTray;

//  ---------------------------------------------------------------------------
type
    //  ʒm`FbN̎
    TTimerType = (ttDAYOFWEEK = 0,  //  jw
                  ttDAY       = 1,  //  tw
                  ttMONTHDAY  = 2,  //  w
                  ttGETTICK   = 3   //  oߎ
    );
const
    //  \L
    S_TIMERTYPE: array[TTimerType] of string
    = ('jw', 'tw', 'w', 'oߎ');

type
    //  ݒێNX
    TReminderConfig = class
    private
        FEnable: Boolean;               //  L
        FTime: TDateTime;               //  w莞
        FTimerType: TTimerType;         //  N̕@
        FFlagOfDayOfWeek: Byte;         //  jw莞̐ݒe
        FFlagOfDay: LongWord;           //  tw莞̐ݒe
        FText: string;                  //  \镶
        FMsgType: TMessageType;         //  \@
        FIconType: TBalloonIconType;    //  ACR̃^Cv

        procedure SetText(const Value: string);
        function GetText(): string;
        procedure SetFlagOfDay(index: integer; const Value: Boolean);
        function GetFlagOfDay(index: integer): Boolean;
        procedure SetFlagOfDayOfWeek(index: integer; const Value: Boolean);
        function GetFlagOfDayOfWeek(index: integer): Boolean;
        procedure SetTime(const Value: TDateTime);

        procedure SetFlagTextOfDay(const CommaText: string);
        function GetFlagTextOfDay(): string;
        procedure SetFlagTextOfDayOfWeek(const CommaText: string);
        function GetFlagTextOfDayOfWeek(): string;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Assign(const Src: TReminderConfig);

        property Enable: Boolean read FEnable write FEnable;
        property Time: TDateTime read FTime write SetTime;
        property TimerType: TTimerType read FTimerType write FTimerType;
        property FlagOfDayOfWeek[index: integer]: Boolean read GetFlagOfDayOfWeek write SetFlagOfDayOfWeek;
        property FlagOfDay[index: integer]: Boolean read GetFlagOfDay write SetFlagOfDay;
        property Text: string read GetText write SetText;
        property MsgType: TMessageType read FMsgType write FMsgType;
        property IconType: TBalloonIconType read FIconType write FIconType;

        property FlagTextOfDayOfWeek: string read GetFlagTextOfDayOfWeek write SetFlagTextOfDayOfWeek;
        property FlagTextOfDay: string read GetFlagTextOfDay write SetFlagTextOfDay;

        function ToString(): string;
        procedure LoadFromStrings(S: TStrings);
        procedure SaveToStrings(S: TStrings);

        function DoYou(const Check: TDateTime): Boolean;
        procedure Execute();
    end;

    //  ݒێNXǗNX
    TReminderConfigList = class
    private
        FList: TObjectList;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure LoadFromFile(const IniPath: string);
        procedure SaveToFile(const IniPath: string);

        function Count(): integer;
        function Item(const index: integer): TReminderConfig;
        function DoRemind(var Iam: TReminderConfig): Boolean;

        function Add(const Config: TReminderConfig): integer;
        procedure Delete(const index: integer);
        procedure Clear();
        procedure Move(const OldIndex, NewIndex: integer);
    end;

var
    //  eXgEƗpݒNXCX^X
    TempConfig: TReminderConfig = nil;
    //  ǗNXCX^X
    ConfigList: TReminderConfigList = nil;

implementation

var
    WorkList: TStringList = nil;

//  ---------------------------------------------------------------------------
const
    //  jw莞tO`FbNp
    CHECK_DAYOFWEEK: array[1..7] of Byte
    = (
        1, 2, 4, 8, 16, 32, 64
    );

    //  tw莞tO`FbNp
    CHECK_DAY: array[1..31] of LongWord
    = (
        1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,
        65536,131072,262144,524288,1048576,2097152,4194304,8388608,
        16777216,33554432,67108864,134217728,268435456,536870912,1073741824
    );

//  ---------------------------------------------------------------------------
//  ̃tOĂ?
function IncludeFlag(const Flags, Flag: integer): Boolean;
begin
    Result := (Flags and Flag = Flag);
end;

//  ---------------------------------------------------------------------------
//  ͈̓`FbN
function RangeCheckDow(const index: integer): Boolean;
begin
    Result := (Low(CHECK_DAYOFWEEK) <= index) and (index <= High(CHECK_DAYOFWEEK));
end;

//  ---------------------------------------------------------------------------
function RangeCheckD(const index: integer): Boolean;
begin
    Result := (Low(CHECK_DAY) <= index) and (index <= High(CHECK_DAY));
end;

//  ---------------------------------------------------------------------------
//  R}eLXgjtOɕϊ
function CommaText2DayOfWeekFlag(const CommaText: string): Byte;

    procedure IncFlag(const Flag: integer);
    begin
        //  ߂ĂȂ
        if not IncludeFlag(Result, CHECK_DAYOFWEEK[Flag]) then
        begin
            //  tO̒lZ
            Inc(Result, CHECK_DAYOFWEEK[Flag]);
        end;
    end;

var
    i, Flag: integer;
    APos, j, First, Last: integer;
begin
    Result := 0;
    //  
    WorkList.CommaText := CommaText;
    for i := 0 to WorkList.Count - 1 do
    begin
        //  nCt܂܂Ă邩H
        APos := Pos('-', WorkList[i]); 
        if (APos > 0) then
        begin
            //  OƌɕāAꂼ𐔎ɕϊ
            First := StrToIntDef(Copy(WorkList[i], 1, APos - 1), -1);
            Last  := StrToIntDef(Copy(WorkList[i], APos + 1, Length(WorkList[i])), -1);
            //  ͈͓Ȃ炻̊ԂA
            if RangeCheckDow(First) and RangeCheckDow(Last) then
            begin
                for j := First to Last do
                begin
                    IncFlag(j);
                end;
            end;
        end
        else
        begin
            //  lɕϊ(..  1..7 ɑΉ)
            Flag := StrToIntDef(WorkList[i], -1);
            if RangeCheckDow(Flag) then IncFlag(Flag);
        end;
    end;
end; 
{
//  ---------------------------------------------------------------------------
//  R}eLXgttOɕϊ
function CommaText2DayFlag(const CommaText: string): LongWord;
var
    i, Flag: integer;
begin
    Result := 0;
    //  
    WorkList.CommaText := CommaText;
    for i := 0 to WorkList.Count - 1 do
    begin
        //  lɕϊ
        Flag := StrToIntDef(WorkList[i], -1);
        //  ͈͓Ȃ
        if RangeCheckD(Flag) then
        begin
            //  tO̒lZ
            Inc(Result, CHECK_DAY[Flag]);
        end;
    end;
end;
}
//  ---------------------------------------------------------------------------
//  R}eLXgttOɕϊ
function CommaText2DayFlag(const CommaText: string): LongWord;

    procedure IncFlag(const Flag: integer);
    begin
        //  ߂ĂȂ
        if not IncludeFlag(Result, CHECK_DAY[Flag]) then
        begin
            //  tO̒lZ
            Inc(Result, CHECK_DAY[Flag]);
        end;
    end;

var
    i, Flag: integer;
    APos, j, First, Last: integer;
begin
    Result := 0;
    //  
    WorkList.CommaText := CommaText;
    for i := 0 to WorkList.Count - 1 do
    begin
        //  nCt܂܂Ă邩H
        APos := Pos('-', WorkList[i]); 
        if (APos > 0) then
        begin
            //  OƌɕāAꂼ𐔎ɕϊ
            First := StrToIntDef(Copy(WorkList[i], 1, APos - 1), -1);
            Last  := StrToIntDef(Copy(WorkList[i], APos + 1, Length(WorkList[i])), -1);
            //  ͈͓Ȃ炻̊ԂA
            if RangeCheckD(First) and RangeCheckD(Last) then
            begin
                for j := First to Last do
                begin
                    IncFlag(j);
                end;
            end;
        end
        else
        begin
            //  lɕϊ(..  1..7 ɑΉ)
            Flag := StrToIntDef(WorkList[i], -1);
            if RangeCheckD(Flag) then IncFlag(Flag);
        end;
    end;
end; 

//  ---------------------------------------------------------------------------
//  ̗jǂH
function IsTargetDayOfWeek(const Flag: Byte; const CheckDayOfWeek: integer): Boolean;
begin
    //  ͈͒Ăm
    Result := IncludeFlag(Flag, CHECK_DAYOFWEEK[CheckDayOfWeek]);
end;

//  ---------------------------------------------------------------------------
//  jtOR}eLXgɕϊ
function DayOfWeekFlag2CommaText(const Flag: Byte): string;
var
    i: integer;
begin
    Result := '';
    WorkList.Clear;
    for i := Low(CHECK_DAYOFWEEK) to High(CHECK_DAYOFWEEK) do
    begin
        //  tO܂ނȂ
        if IsTargetDayOfWeek(Flag, i) then
        begin
            WorkList.Add(IntToStr(i));
        end;
    end;
    Result := WorkList.CommaText;
end; 

//  ---------------------------------------------------------------------------
//  ̓tǂH
function IsTargetDay(const Flag: LongWord; const CheckDay: integer): Boolean;
begin
    //  ͈͒Ăm
    Result := IncludeFlag(Flag, CHECK_DAY[CheckDay]);
end;

//  ---------------------------------------------------------------------------
//  ttOR}eLXgɕϊ
function DayFlag2CommaText(const Flag: LongWord): string;
var
    i: integer;
begin
    Result := '';
    WorkList.Clear;
    for i := Low(CHECK_DAY) to High(CHECK_DAY) do
    begin
        //  tO܂ނȂ
        if IsTargetDay(Flag, i) then
        begin
            WorkList.Add(IntToStr(i));
        end;
    end;
    Result := WorkList.CommaText;
end; 


//  ---------------------------------------------------------------------------
//  RXgN^
constructor TReminderConfig.Create();
begin
    FEnable          := false;
    FTime            := 0;
    FTimerType       := ttDAYOFWEEK;
    FFlagOfDayOfWeek := 0;
    FFlagOfDay       := 0;
    FText            := '';
    FMsgType         := mtBALLOON;
    FIconType        := bitINFO;
end;

//  ---------------------------------------------------------------------------
//  fXgN^
destructor TReminderConfig.Destroy();
begin
    //
end;

//  ---------------------------------------------------------------------------
//  Rs[
procedure TReminderConfig.Assign(const Src: TReminderConfig);
begin
    Self.FEnable          := Src.FEnable         ;
    Self.FTime            := Src.FTime           ;
    Self.FTimerType       := Src.FTimerType      ;
    Self.FFlagOfDayOfWeek := Src.FFlagOfDayOfWeek;
    Self.FFlagOfDay       := Src.FFlagOfDay      ;
    Self.FText            := Src.FText           ;
    Self.FMsgType         := Src.FMsgType        ;
    Self.FIconType        := Src.FIconType       ;
end;

//  ---------------------------------------------------------------------------
//  ւ̃vpeBANZX
const
    REP_CRLF = #255#255;

procedure TReminderConfig.SetText(const Value: string);
begin
    FText := StringReplace(Value, #13#10, REP_CRLF, [rfReplaceAll]);
end;

//  ---------------------------------------------------------------------------
function TReminderConfig.GetText(): string;
begin
    Result := StringReplace(FText, REP_CRLF, #13#10, [rfReplaceAll]);
end;

//  ---------------------------------------------------------------------------
//  tw莞̃tOւ̃vpeBANZX
procedure TReminderConfig.SetFlagOfDay(index: integer; const Value: Boolean);
begin
    //  ͈͓Ȃ
    if RangeCheckD(index) then
    begin
        //  ݒ肵ꍇAݒς݂łȂ
        if (Value) and (not IsTargetDay(FFlagOfDay, index)) then
            Inc(FFlagOfDay, CHECK_DAY[index])

        //  ꍇAݒ肵Ă
        else if (not Value) and IsTargetDay(FFlagOfDay, index) then
            Dec(FFlagOfDay, CHECK_DAY[index])
        ;
    end;
end;

//  ---------------------------------------------------------------------------
function TReminderConfig.GetFlagOfDay(index: integer): Boolean;
begin
    Result := RangeCheckD(index) and IsTargetDay(FFlagOfDay, index);
end;

//  ---------------------------------------------------------------------------
//  jw莞̃tOւ̃vpeBANZX
procedure TReminderConfig.SetFlagOfDayOfWeek(index: integer; const Value: Boolean);
begin
    //  ͈͓Ȃ
    if RangeCheckDow(index) then
    begin
        //  ݒ肵ꍇAݒς݂łȂ
        if (Value) and (not IsTargetDayOfWeek(FFlagOfDayOfWeek, index)) then
            Inc(FFlagOfDayOfWeek, CHECK_DAYOFWEEK[index])

        //  ꍇAݒ肵Ă
        else if (not Value) and IsTargetDayOfWeek(FFlagOfDayOfWeek, index) then
            Dec(FFlagOfDayOfWeek, CHECK_DAYOFWEEK[index])
        ;
    end;
end;

//  ---------------------------------------------------------------------------
function TReminderConfig.GetFlagOfDayOfWeek(index: integer): Boolean;
begin
    Result := RangeCheckDow(index) and IsTargetDayOfWeek(FFlagOfDayOfWeek, index);
end;

//  ---------------------------------------------------------------------------
//  tw莞̃tOւ̃vpeBANZX
procedure TReminderConfig.SetFlagTextOfDay(const CommaText: string);
begin
    FFlagOfDay := CommaText2DayFlag(CommaText);
end;

//  ---------------------------------------------------------------------------
function TReminderConfig.GetFlagTextOfDay(): string;
begin
    Result := DayFlag2CommaText(FFlagOfDay)
end;

//  ---------------------------------------------------------------------------
//  jw莞̃tOւ̃vpeBANZX
procedure TReminderConfig.SetFlagTextOfDayOfWeek(const CommaText: string);
begin
    FFlagOfDayOfWeek := CommaText2DayOfWeekFlag(CommaText);
end;

//  ---------------------------------------------------------------------------
function TReminderConfig.GetFlagTextOfDayOfWeek(): string;
begin
    Result := DayOfWeekFlag2CommaText(FFlagOfDayOfWeek)
end;


//  ---------------------------------------------------------------------------
//  փvpeBANZX
procedure TReminderConfig.SetTime(const Value: TDateTime);
begin
    //  N΂
    FTime := TimeOf(Value);
end;

//  ---------------------------------------------------------------------------
//  ŕ\
function TReminderConfig.ToString(): string;
const
    S_ENABLE: array[Boolean] of string = ('', 'L');
begin
    Result := S_ENABLE[FEnable]
            + ' ' + FormatDateTime('hh:nn', FTime)
            + ' ' + S_TIMERTYPE[FTimerType]
            + ' ' + S_MSGTYPE[FMsgType]
            + ' ' + S_ICONTYPE[FIconType]
            + ' ' + Copy(FText, 1, 20) + '...';
end;

//  ---------------------------------------------------------------------------
//  INI`̕񃊃Xgf[^Ǎ
procedure TReminderConfig.LoadFromStrings(S: TStrings);
begin
    FEnable           := StrToBoolDef(S.Values['Enable'], false);
    FTime             := StrToTimeDef(S.Values['Time'], 0);
    FTimerType        := TTimerType(StrToIntDef(S.Values['TimerType'], Ord(Low(TTimerType))));
    FFlagOfDayOfWeek  := CommaText2DayOfWeekFlag(S.Values['FlagOfDayOfWeek']);
    FFlagOfDay        := CommaText2DayFlag(S.Values['FlagOfDay']);
    Text              := S.Values['Text'];
    FMsgType          := TMessageType(StrToIntDef(S.Values['MsgType'], Ord(Low(TMessageType))));
    FIconType         := TBalloonIconType(StrToIntDef(S.Values['IconType'], Ord(Low(TBalloonIconType))));
end;

//  ---------------------------------------------------------------------------
//  INI`ŕ񃊃XgɃf[^
procedure TReminderConfig.SaveToStrings(S: TStrings);
begin
    S.Values['Enable']          := BoolToStr(FEnable, true);
    S.Values['Time']            := TimeToStr(FTime);
    S.Values['TimerType']       := IntToStr(Ord(FTimerType));
    S.Values['FlagOfDayOfWeek'] := DayOfWeekFlag2CommaText(FFlagOfDayOfWeek);
    S.Values['FlagOfDay']       := DayFlag2CommaText(FFlagOfDay);
    S.Values['Text']            := Text;
    S.Values['MsgType']         := IntToStr(Ord(FMsgType));
    S.Values['IconType']        := IntToStr(Ord(FIconType));
end;

//  ---------------------------------------------------------------------------
//  ǂH
function TReminderConfig.DoYou(const Check: TDateTime): Boolean;
var
    Temp: integer;
begin
    //  ߂l
    Result := false;
    //  Ȃʖ
    if (not FEnable) then exit;
    //  ݒ肳ĂȂĂʖ
    if (Text = '') then exit;
    //  ''ႤȂʖ
    if (HourOf(FTime) <> HourOf(Check)) then exit;
    //  ''ႤȂʖ
    if (MinuteOf(FTime) <> MinuteOf(Check)) then exit;
    //  [h
    if (FTimerType = ttDAYOFWEEK) then
    begin
        //  j擾
        Temp := DayOfTheWeek(Check);
        //  `FbN
        Result := IsTargetDayOfWeek(FFlagOfDayOfWeek, Temp);
    end
    else if (FTimerType = ttDAY) then
    begin
        //  t擾
        Temp := DayOf(Check);
        //  `FbN
        Result := IsTargetDay(FFlagOfDay, Temp);
    end
    else if (FTimerType = ttMONTHDAY) then
    begin
        //  
        Result := false;
    end
    else if (FTimerType = ttGETTICK) then
    begin
        //  
        Result := false;
    end;
end;

//  ---------------------------------------------------------------------------
//  s
procedure TReminderConfig.Execute();
begin
    SimpleTray.ShowBalloon(
        Text,
        FormatDateTime('yyyy/mm/dd hh:nn', Now),
        IconType,
        MsgType);
end;


//  ---------------------------------------------------------------------------
//  RXgN^
constructor TReminderConfigList.Create();
begin
    FList := TObjectList.Create(true);
end;
//  ---------------------------------------------------------------------------
//  fXgN^
destructor TReminderConfigList.Destroy();
begin
    FList.Free;
end;
//  ---------------------------------------------------------------------------
//  Ǎ
procedure TReminderConfigList.LoadFromFile(const IniPath: string);
var
    Ini: TIniFile;
    Sections: TStrings;
    SectionValues: TStrings;
    i: integer;
    Config: TReminderConfig;
begin
    Ini := TIniFile.Create(IniPath);
    Sections := TStringList.Create;
    SectionValues := TStringList.Create;
    try
        //  ̃ZNV̐ݒNXɑΉ
        Ini.ReadSections(Sections);
        for i := 0 to Sections.Count - 1 do
        begin
            //  ZNV̑SĂ̐ݒǂݏo
            Ini.ReadSectionValues(Sections[i], SectionValues);
            //  ݒNX쐬
            Config := TReminderConfig.Create;
            //  ݒ肵
            Config.LoadFromStrings(SectionValues);
            //  Xgɒǉ
            FList.Add(Config);
        end;
    finally
        SectionValues.Free;
        Sections.Free;
        Ini.Free;
    end;
end;

//  ---------------------------------------------------------------------------
//  ۑ
procedure TReminderConfigList.SaveToFile(const IniPath: string);
var
    Sections: TStrings;
    SectionValues: TStrings;
    i: integer;
    Config: TReminderConfig;
begin
    Sections := TStringList.Create;
    SectionValues := TStringList.Create;
    try
        for i := 0 to Count - 1 do
        begin
            Config := Item(i);
            SectionValues.Clear;
            Config.SaveToStrings(SectionValues);
            Sections.Add(Format('[ReminderConfig%5.5d]', [i]));
            Sections.AddStrings(SectionValues);
        end;

        //  ۑ
        Sections.SaveToFile(IniPath);
    finally
        SectionValues.Free;
        Sections.Free;
    end;
end;

//  ---------------------------------------------------------------------------
//  
function TReminderConfigList.Count(): integer;
begin
    Result := FList.Count;
end;

//  ---------------------------------------------------------------------------
//  ݒNX
function TReminderConfigList.Item(const index: integer): TReminderConfig;
begin
    Result := TReminderConfig(FList.Items[index]);
end;

//  ---------------------------------------------------------------------------
//  Ă
function TReminderConfigList.DoRemind(var Iam: TReminderConfig): Boolean;
var
    i: integer;
    Config: TReminderConfig;
    NowTime: TDateTime;
begin
    Iam := nil;
    Result := false;
    NowTime := Now();
    for i := 0 to Count - 1 do
    begin
        Config := Item(i);
        if (Config.DoYou(NowTime)) then
        begin
            Iam := Config;
            Result := true;
            break;
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  ǉ
function TReminderConfigList.Add(const Config: TReminderConfig): integer;
begin
    Result := FList.Add(Config);
end;

//  ---------------------------------------------------------------------------
//  폜
procedure TReminderConfigList.Delete(const index: integer);
begin
    FList.Delete(index);
end;

//  ---------------------------------------------------------------------------
//  NA
procedure TReminderConfigList.Clear();
begin
    FList.Clear;
end;

//  ---------------------------------------------------------------------------
//  ړ
procedure TReminderConfigList.Move(const OldIndex, NewIndex: integer);
begin
    FList.Move(OldIndex, NewIndex);
end;

//  ---------------------------------------------------------------------------
initialization
    TempConfig := TReminderConfig.Create;
    ConfigList := TReminderConfigList.Create;
    WorkList := TStringList.Create;
//  ---------------------------------------------------------------------------
finalization
    WorkList.Free;
    ConfigList.Free;
    TempConfig.Free;
//  ---------------------------------------------------------------------------
end.

